
module Commands

  def Commands.help(options)
    if !options.params.empty? && Commands.respond_to?(options.params.first.to_sym)
      method_name = "print_#{options.params.first}_help".to_sym
      Commands.method(method_name).call()
    else
      print_general_help
    end
  end

  private

  def Commands.print_general_help
    puts <<-END.gsub(/^ {6}/, '')
      p4util [command] [params]

      Executes various commands useful when writing Perforce applications.

      Use `p4util help [command]` for more information on each command.

      List of available commands:
        download - Download Perforce binaries for your platform
        init - Seed the local p4d instance using local configuration files
        kill - Shutdown p4d processes using SIGTERM
        start - Spawn the p4d process in your working directory

      Additional 'commands' you can use for more information:
        version - Print the version string
        rake - Some notes on how to use the Rake tasks
    END
  end
end