require 'commands/init/init_model'

module Commands
  module Init
    # Each trigger model instance adds an array of triggers
    class TriggerModel < InitModel
      inheritable_attributes :triggers

      # An array of strings
      @triggers = nil

      def self.abstract
        true
      end

      def initialize
        @triggers = self.class.triggers
      end

      def execute(p4, models=nil, super_user=nil)
        puts "triggers: #{@triggers}"

        triggers = p4.run('triggers', '-o')[0]['Triggers']
        puts "current triggers: #{triggers}"
        triggers = [] if triggers.nil?

        @triggers.each { |t| triggers << t }

        p4.input = {
            'Triggers' => triggers
        }
        p4.run('triggers', '-i')
      end
    end
  end
end