
module Commands

  def Commands.rake(options)
    print_rake_help
  end

  private

  def Commands.print_rake_help
    puts <<-END.gsub(/^ {6}/, '')
      Use rake to drive p4util commands

      Example usage in your Rakefile:

          require 'p4util/tasks'

          P4Util::Tasks.new do |p4util|
            p4util.version = 'r14.2'
            p4util.p4_init_dir = 'spec/init.base'
          end

      This defines three tasks for you:

      * `p4init` - See 'p4util help init'
      * `p4kill` - See 'p4util help kill'
      * `p4reset` - Calls p4kill then removes the /tmp/p4util/p4droot folder

      (This assumes you have installed p4util or setup the p4util gem dependency.)

      The `version` property specifies the version of p4d to download and run.
      It mirrors the version directory names of ftp.perforce.com at the moment.

      The `p4_init_dir` property indicates a directory of ruby scripts that
      define the script files for the p4util init command.
    END
  end
end