
require 'rbconfig'

module OsUtil

  def OsUtil.p4d_executable
    if windows?
      'p4d.exe'
    else
      'p4d'
    end
  end

  def OsUtil.p4d_path
    File.expand_path(File.join(Conventions.working_dir, OsUtil.p4d_executable))
  end

  def OsUtil.p4_executable
    if windows?
      'p4.exe'
    else
      'p4'
    end
  end

  def OsUtil.p4_path
    File.expand_path(File.join(Conventions.working_dir, OsUtil.p4_executable))
  end

  def OsUtil.osx?
    RbConfig::CONFIG['host_os'] =~ /darwin/
  end

  def OsUtil.windows?
    RbConfig::CONFIG['host_os'] =~ /mswin|mingw|cygwin/
  end

  def OsUtil::linux?
    RbConfig::CONFIG['host_os'] =~ /linux/
  end

  def OsUtil.platform_dir_prefix
    if osx?
      'darwin90'
    elsif windows?
      'nt'
    elsif linux?
      'linux26'
    else
      raise "OsUtil doesn't know platform: #{RbConfig::CONFIG['host_os']}"
    end
  end

  def OsUtil.ftp_download_dir(version)
    "perforce/#{version}/bin.#{platform_dir_prefix}#{RbConfig::CONFIG['build_cpu']}"
  end

  def OsUtil.p4api_file
    if windows?
      raise 'hey you need a visual studio version defined somehow'
      'p4api.zip'
    else
      'p4api.tgz'
    end
  end

  def OsUtil.p4api_path
    File.expand_path(File.join(Conventions.working_dir, OsUtil.p4api_file))
  end
end